// AuxFrame.cpp : implementation file
//

#include "stdafx.h"
#include "Postman.h"
#include "AuxFrame.h"
#include "MailDoc.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAuxFrame

IMPLEMENT_DYNCREATE(CAuxFrame, CFrameWnd)

CAuxFrame::CAuxFrame()
{
}

CAuxFrame::~CAuxFrame()
{
}


BEGIN_MESSAGE_MAP(CAuxFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CAuxFrame)
	ON_COMMAND(IDM_CLOSE, OnClose)
	ON_WM_CREATE()
	ON_EN_KILLFOCUS(IDC_SUBJECT_RW, OnKillfocusSubject)
	ON_EN_KILLFOCUS(IDC_SUBJECT_RO, OnKillfocusSubject)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CAuxFrame message handlers

void CAuxFrame::OnClose() 
{
	CDocument *pDoc = GetActiveDocument( );
	if( pDoc && pDoc->CanCloseFrame( this ) )
	{		
		DestroyWindow();
	}
}

int CAuxFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
		
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_READ))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CAuxFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CAuxFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

BOOL CAuxFrame::CreateAddressBar(UINT Id)
{
	
	if (!m_wndDialogBar.Create(this,Id,
      CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_GRIPPER , Id) )
	{
		TRACE0("Failed to create Dialog bar\n");
		return FALSE;      // fail to create
	}
	RecalcLayout( );
	GetActiveView()->SetFocus();
	return TRUE;
}

void CAuxFrame::SetDlgItem(UINT Id, CString &Value)
{
	CEdit *pEdit = (CEdit *) m_wndDialogBar.GetDlgItem( Id );
	#ifdef _DEBUG
		pEdit->AssertValid();
	#endif
	pEdit->SetWindowText( Value );
}

void CAuxFrame::GetDlgItem(UINT Id, CString &Value)
{
	CEdit *pEdit = (CEdit *) m_wndDialogBar.GetDlgItem( Id );
	#ifdef _DEBUG
		pEdit->AssertValid();
	#endif
	pEdit->GetWindowText( Value );
}

BOOL CAuxFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style = cs.style & ~FWS_ADDTOTITLE;
	return CFrameWnd::PreCreateWindow(cs);
	
}

void CAuxFrame::OnKillfocusSubject() 
{
	CView *View = GetActiveView();
	if( View )
		View->SetFocus();
}

/*
void CAuxFrame::OnSaveAs() 
{
	//AfxMessageBox(" Saving ass");		
	CMailDoc *pDoc = (CMailDoc *) GetActiveDocument( );	
 	CFileDialog FileDlg( FALSE, "eml",NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ENABLESIZING | OFN_EXPLORER,
		"E-Mail Files (*.eml)|*.eml||", this);
	if( FileDlg.DoModal() == IDOK)
	{
		if( pDoc->Compose )
			pDoc->SaveFile( FileDlg.GetPathName() );
	}
}
*/