// ListPane.cpp : implementation file
//

#include "stdafx.h"
#include "Postman.h"
#include "ListPane.h"
#include "MainFrm.h"
#include "TreePane.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CPostmanApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CListPane

IMPLEMENT_DYNCREATE(CListPane, CListView)

CListPane::CListPane()
{
	
}

CListPane::~CListPane()
{
}


BEGIN_MESSAGE_MAP(CListPane, CListView)
	//{{AFX_MSG_MAP(CListPane)
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListPane drawing

void CListPane::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CListPane diagnostics

#ifdef _DEBUG
void CListPane::AssertValid() const
{
	CListView::AssertValid();
}

void CListPane::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CListPane message handlers


void CListPane::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();
	CListCtrl &ListCtrl = GetListCtrl( );
	CWinApp *App = AfxGetApp();
	HICON hIcon = App->LoadIcon( IDR_MAINFRAME );

	//Inserting Columns
	CRect Rect;
	GetWindowRect(&Rect);

	ListCtrl.InsertColumn( 0, "From",LVCFMT_LEFT,(Rect.right - Rect.left )/3);
	ListCtrl.InsertColumn( 1, "To",LVCFMT_LEFT,(Rect.right - Rect.left )/3);
	ListCtrl.InsertColumn( 2, "Subject",LVCFMT_LEFT,(Rect.right - Rect.left )*2/5);
	ListCtrl.InsertColumn( 3, "Date",LVCFMT_LEFT,(Rect.right - Rect.left )/6);
	ListCtrl.InsertColumn( 4, "Size",LVCFMT_LEFT,(Rect.right - Rect.left )/12);

	ImageList.Create( 16, 16, ILC_COLOR16, 5,1);
	ImageList.SetBkColor( RGB(255,255,255) );
	ImageList.Add( hIcon );	//0
	ImageList.Add( AfxGetApp()->LoadIcon( IDI_DOWNLOADED ) );	// 1
	ImageList.Add( AfxGetApp()->LoadIcon( IDI_SEND ) );			// 2
	ImageList.Add( AfxGetApp()->LoadIcon( IDR_READ ) );			// 3
	ListCtrl.SetImageList( &ImageList, LVSIL_SMALL);
	ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT |LVS_EX_GRIDLINES );

	CMainFrame *MainWnd = (CMainFrame *)App->GetMainWnd();
	CString MailStore = CPostmanApp::AppData + "Inbox\\";
	MainWnd->ReadMailStore( MailStore ,MainWnd->pInBox);
	MailStore = CPostmanApp::AppData + "OutBox\\";
	MainWnd->ReadMailStore( MailStore ,MainWnd->pOutBox);
	MailStore = CPostmanApp::AppData + "Sent To\\";
	MainWnd->ReadMailStore( MailStore ,MainWnd->pSentTo);
	MailStore = CPostmanApp::AppData + "Deleted\\";
	MainWnd->ReadMailStore( MailStore ,MainWnd->pDeleted);
}

/*
void CListPane::OnViewList() 
{
	// TODO: Add your command handler code here
	if (GetViewType() != LVS_LIST)
		SetViewType(LVS_LIST);
}

void CListPane::OnViewDetails() 
{
	// TODO: Add your command handler code here
	if (GetViewType() != LVS_REPORT)
			SetViewType(LVS_REPORT);
}

void CListPane::OnViewLargeicons() 
{
	// TODO: Add your command handler code here
	if (GetViewType() != LVS_ICON)
		SetViewType(LVS_ICON);
}

void CListPane::OnViewSmallicons() 
{
	// TODO: Add your command handler code here
	if (GetViewType() != LVS_SMALLICON)
		SetViewType(LVS_SMALLICON);
}

BOOL CListPane::SetViewType(DWORD dwViewType)
{
	return(ModifyStyle(LVS_TYPEMASK,dwViewType & LVS_TYPEMASK));
}

DWORD CListPane::GetViewType()
{
	return(GetStyle() & LVS_TYPEMASK);
}
*/

BOOL CListPane::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle | LVS_REPORT | LVS_SHOWSELALWAYS , rect, pParentWnd, nID, pContext);
	// LVS_SINGLESEL
}

void CListPane::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CListPane::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CListCtrl &MailListCtrl = GetListCtrl();
	POSITION pos = MailListCtrl.GetFirstSelectedItemPosition( ) ;
	if(pos == NULL)
		return;
	CWinApp *App = AfxGetApp();
	CMainFrame *MainWnd = (CMainFrame *)App->GetMainWnd();	
	CTreePane *TreePane = ( CTreePane *) MainWnd->m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		int MessageNo = MailListCtrl.GetItemData( MailListCtrl.GetNextSelectedItem(pos) );
		CMail * Mail = MainWnd->pMailList->GetMail( MessageNo );
		if( Mail )
		{
			FILE*fp;

			if( !Mail->FileName.IsEmpty() && ( fp=fopen( (LPCSTR)Mail->FileName, "r") ) )
			{
				fclose(fp);
				MainWnd->OnRead();
				return;
			}
			MainWnd->OnDownload();
		}
	}
	else
		MainWnd->OnRead();
	*pResult = 0;
}

void CListPane::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	CListCtrl &ListCtrl = GetListCtrl( );
	ListCtrl.SortItems( CListPane::SortDate, (LPARAM)&ListCtrl);
	*pResult = 0;
}

int CALLBACK CListPane::SortDate(LPARAM lParam1, LPARAM lParam2, LPARAM lpListCtrl)
{
	CListCtrl *pList = (CListCtrl *)lpListCtrl;
	int ret = 0, ItemData, Count;
	CString Date1, Date2;
	CTime Time1, Time2;
	Count = pList->GetItemCount();
	for( int i=0; i < Count; i++ )
	{
		ItemData = pList->GetItemData( i );
		if( ItemData == lParam1)
		{
			Date1 = pList->GetItemText( i, 3);
		}
		else if( ItemData == lParam2)
		{
			Date2 = pList->GetItemText( i, 3);
		}
	}
	Time1 = GetTime( Date1 );
	Time2 = GetTime( Date2 );
	
	if( Time1 > Time2 )
		return -1;
	else if( Time1 < Time2)
		return 1;
	return 0;

}

CTime CListPane::GetTime(CString Date)
{
	
	int dd, mm, yy, hr, min;
	sscanf( (LPCSTR)Date, "%d-%d-%d %d:%d",&dd, &mm, &yy, &hr, &min );
	return CTime( yy, mm, dd, hr, min, 0 );
	//return Time;
}

void CListPane::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CMainFrame *MainWnd = (CMainFrame *)theApp.GetMainWnd();
	if( nChar == VK_RETURN )
		MainWnd->OnRead();
	CListView::OnChar(nChar, nRepCnt, nFlags);
}

void CListPane::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if( nChar == VK_DELETE )
	{
		SHORT State = GetKeyState( VK_SHIFT );
		if( State == -127 || State == -128 );
			//	AfxMessageBox( "Shift Delete pressed ");
		else
		{
			CMainFrame *MainWnd = (CMainFrame *)theApp.GetMainWnd();
			MainWnd->OnDelete();
		}
			
	}
	CListView::OnKeyDown(nChar, nRepCnt, nFlags);
}
