// Mail.h: interface for the CMail class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAIL_H__B1536921_56E9_11D5_8286_5254AB2AE30A__INCLUDED_)
#define AFX_MAIL_H__B1536921_56E9_11D5_8286_5254AB2AE30A__INCLUDED_

#include "POPSocket.h"	// Added by ClassView
#include "SndRecvDlg.h"	// Added by ClassView
#include "SMTPSocket.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMainFrame;
class CMail  
{
	friend class CMailList;
public:
	BYTE Downloaded;
	BOOL Valid;
	CString To;
	CString CC;
	CString BCC;
	BOOL Error;
	DWORD No;
	CString Subject;
	CString Date;
	CString From;
	CString ID;
	CString FileName;
	DWORD Size;
	CMail * Next;
	CMail();
	virtual ~CMail();
	FILE *pFilePointer;
};

class CMailList
{
	friend class CMainFrame;
public:
	WORD GetCount( CString From);
	CMail* GetMail( CString &UID);
	void CreateReceiveDialogBox();
	void CreateSendDialogBox();
	void OnSMTPQuit();
	void OnPOPQuit();
	void OnSMTPAuthentication( BOOL Success);
	void OnPOPAuthentication(BOOL Success);
	void GetAuthentication( CString &SMTP_Server, CString & POPServer, CString & UserName, CString & Password);
	BOOL Stop(BOOL POP);
	BOOL ForceStop( BOOL POP);
	BOOL MoveTo( DWORD No, CString &Destination, CMailList* DestinationList);
	void OnMailDelete( DWORD No, BOOL Success );
	void DeleteFromServer( DWORD No);
	BOOL ReadInMail();
	WORD GetCount();
	int ImageIdx;
	void OnMailSent(DWORD No , BOOL Success = TRUE);
	void Remove( DWORD No);
	BOOL DeleteMail( DWORD No);
	BOOL ReadInMail( DWORD No );
	void RemoveAll();
	void SendMail(CString &SMTPServer);
	void OnMailReceipt(DWORD No);
	void OnHeaderReceipt(DWORD No, BOOL Done = FALSE);
	void ReceiveMail( CString &, CString &, CString &);
	CMail* GetMail( DWORD No);
	CMail * AddMail( DWORD No);
	CMail * AddMail( );
	CMail *Start;
	CMailList(CMainFrame *pFW);
	virtual ~CMailList();
	CPOPSocket *pPOPSocket;
	CSMTPSocket *pSMTPSocket;
	CString SMTPServer;
	BOOL WaitingForAuthentication;
	BOOL WaitingForPOPQuiting;
private:
	CSndRecvDlg ReceiveDlg;
	CSndRecvDlg SendDlg;
	DWORD GetSize();
	DWORD TotalSize;
	CMainFrame *pFrameWindow;
};
#endif // !defined(AFX_MAIL_H__B1536921_56E9_11D5_8286_5254AB2AE30A__INCLUDED_)
