// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Postman.h"
#include "TreePane.h"
#include "ListPane.h"
#include "MainFrm.h"
#include "MailDoc.h"
#include "AuxFrame.h"
#include "MailView.h"
#include "MixFile.h"
#include "States.h"
#include "EditorDoc.h"
#include "EditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CPostmanApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_RECEIVE, OnReceive)
	ON_COMMAND(IDM_DOWNLOAD, OnDownload)
	ON_UPDATE_COMMAND_UI(IDM_DOWNLOAD, OnUpdateDownload)
	ON_COMMAND(IDM_READ, OnRead)
	ON_UPDATE_COMMAND_UI(IDM_READ, OnUpdateRead)
	ON_COMMAND(IDM_DISCONNECT, OnDisconnect)
	ON_COMMAND(IDM_DELETE, OnDelete)
	ON_UPDATE_COMMAND_UI(IDM_DELETE, OnUpdateDelete)
	ON_UPDATE_COMMAND_UI(IDM_DISCONNECT, OnUpdateDisconnect)
	ON_UPDATE_COMMAND_UI(IDM_RECEIVE, OnUpdateReceive)
	ON_COMMAND(IDM_NEW_MAIL, OnNewMail)
	ON_COMMAND(IDM_SEND, OnSend)
	ON_UPDATE_COMMAND_UI(IDM_SEND, OnUpdateSend)
	ON_COMMAND(IDM_DOWNLOAD_ALL, OnDownloadAll)
	ON_UPDATE_COMMAND_UI(IDM_DOWNLOAD_ALL, OnUpdateDownloadAll)
	ON_COMMAND(IDM_SERVERS, OnServers)
	ON_COMMAND(IDM_USER, OnUser)
	ON_UPDATE_COMMAND_UI(IDM_USER, OnUpdateUser)
	ON_UPDATE_COMMAND_UI(IDM_SERVERS, OnUpdateServers)
	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_SENDDIALOGBOX, OnViewSenddialogbox)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SENDDIALOGBOX, OnUpdateViewSenddialogbox)
	ON_COMMAND(ID_VIEW_RECEIVEDIALOGBOX, OnViewReceivedialogbox)
	ON_UPDATE_COMMAND_UI(ID_VIEW_RECEIVEDIALOGBOX, OnUpdateViewReceivedialogbox)
	ON_COMMAND(IDM_READ_SPECIAL, OnReadSpecial)
	//}}AFX_MSG_MAP
	ON_MESSAGE( WM_USER, OnAddition )
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	pMailList = NULL;	
	pInBox = new CMailList( this );
	pOutBox = new CMailList( this );
	pSentTo = new CMailList( this );
	pDeleted = new CMailList( this );
	pInBox->ImageIdx = 0;
	pOutBox->ImageIdx = 2;
	pSentTo->ImageIdx = 2;
	pDeleted->ImageIdx = 1;
}

CMainFrame::~CMainFrame()
{
	delete pInBox;
	delete pOutBox;
	if( pMailList )
		delete pMailList;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	SIZE sizeInit;
	sizeInit.cy=10;
	sizeInit.cx=150;

	if(m_wndSplitter.CreateStatic(this,1,2)
		&& m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CListPane), sizeInit, pContext )
		&& m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CTreePane), sizeInit, pContext ) 
		) 
	{
		return TRUE;
	}
	else
		return FALSE;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	cs.style = cs.style & ~FWS_ADDTOTITLE;
	return TRUE;

}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnHeaderReceipt(DWORD No, BOOL Done )
{
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( ! pMailList )
		return;
	CMail *Mail = pMailList->GetMail( No );
 
	 //Checking if the mail has been downloaded...
	CMail *InBoxMail = pInBox->GetMail( Mail->ID );
	CFileStatus Status;
	

	if( InBoxMail && CFile::GetStatus( InBoxMail->FileName, Status ) )
	{
		Mail->FileName = InBoxMail->FileName;
	}
	else
		Mail->Downloaded = FALSE;

	if( TreePane->SelectionFolder == MAILSERVER )
	{
		TreePane->UpdateList( pMailList );
	}
	if( Done )
	{
		TreePane->SetSelection( MAILSERVER );
		AfxMessageBox( "All headers downloaded.");
	}
}

void CMainFrame::OnMailReceipt(DWORD No)
{
	CMail *Mail = pMailList->GetMail( No );
	Mail->Downloaded = TRUE;
	//Writing to MIX file
	CMixFile MixData;
	MixData.UID = Mail->ID;
	MixData.From = Mail->From;
	MixData.To = Mail->To;
	MixData.Date = Mail->Date;
	MixData.Subject = Mail->Subject;
	MixData.FileName = Mail->FileName;
	MixData.Size = Mail->Size;
	MixData.Status = 0;
	MixData.WriteMIX( pMailList->pPOPSocket->MailFolder+"\\Mail Index.mix" );
	
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		TreePane->UpdateList( pMailList );
	}
	
	// 1. Add Mail to mail List

	CMail *MailInBox = pInBox->AddMail( );
	MailInBox->Date = Mail->Date;
	MailInBox->FileName = Mail->FileName ;
	MailInBox->From = Mail->From ;
	MailInBox->ID = Mail->ID ;
	MailInBox->Size = Mail->Size ;
	MailInBox->Subject = Mail->Subject ;
	MailInBox->To = Mail->To ;
	MailInBox->Valid = Mail->Valid ;
	MailInBox->Downloaded = TRUE ;


	// 2. Update Inbox List
	if( TreePane->SelectionFolder == INBOX )
	{
		TreePane->UpdateList( pInBox );
	}

	//3. Checking if there is more to download...
	while( DownloadList.GetUpperBound( ) != -1 )
	{
		int Data = DownloadList.GetAt( 0 );
		Mail = pMailList->GetMail( Data );
		if( Mail )
		{
			FILE*fp;
			if( !Mail->FileName.IsEmpty() )
			{
				fp=fopen( (LPCSTR)Mail->FileName, "r");
				if( fp )
				{
					fclose( fp );
					DownloadList.RemoveAt( 0 );
					continue;
				}
			}
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
			DownloadList.RemoveAt( 0 );
			Download(Mail);
			break;
		}
	}
}

void CMainFrame::OnReceive() 
{
	if( pMailList )
		delete pMailList ; // !!
	pMailList = new CMailList(this);
	pMailList->ImageIdx = 1;
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
		ListPane->GetListCtrl().DeleteAllItems();

	pMailList->ReceiveMail(POPServer, Username, Password);

}


void CMainFrame::OnUpdateDownload(CCmdUI* pCmdUI) 
{
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		if( !pMailList || !pMailList->pPOPSocket || pMailList->pPOPSocket->State != IDLE )
			pCmdUI->Enable( FALSE );
		else
			pCmdUI->Enable( TRUE );
	}
	else
		pCmdUI->Enable( FALSE );
}



void CMainFrame::OnUpdateRead(CCmdUI* pCmdUI) 
{
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{

		if( !pMailList || !pMailList->pPOPSocket || 
				(pMailList->pPOPSocket->State != IDLE &&  pMailList->pPOPSocket->State != NOTCONNECTED ) )
			pCmdUI->Enable( FALSE );
		else
			pCmdUI->Enable( TRUE );
	}
	else
	{
		CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
		CListCtrl &MailListCtrl = ListPane->GetListCtrl();
		POSITION pos = MailListCtrl.GetFirstSelectedItemPosition( ) ;
		if(pos == NULL)
			pCmdUI->Enable( FALSE );
		else
			pCmdUI->Enable( TRUE );
	}
}

void CMainFrame::OnDisconnect() 
{
	if(	!pMailList || !pMailList->pPOPSocket || !pMailList->pPOPSocket->IsConnected() );

	else
	{
		pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
		pMailList->pPOPSocket->Quit();
		AfxMessageBox("Termination proceedings commencing...");
	}		
}

void CMainFrame::OnDelete() 
{
	CString Message;
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	
	int Count = MailListCtrl.GetSelectedCount( );
	if( Count == 0 )
	{
		MessageBox("Select an item to delete please..");
		return;
	}
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		if( !pMailList || !pMailList->pPOPSocket || pMailList->pPOPSocket->State != IDLE )
		{
			return;
		}

		pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
		int nItem = -1;
		WORD MessageNo = 0;
		for (int i=0; i < Count; i++)
		{
			nItem = MailListCtrl.GetNextItem(nItem, LVNI_SELECTED);
			if( nItem == -1 )
				break;
			MessageNo = ( WORD ) MailListCtrl.GetItemData( nItem );
			DeleteList.Add( MessageNo );
		}

		if ( DeleteList.GetUpperBound( ) != -1 )
		{
			MessageNo = DeleteList.GetAt( 0 );
			DeleteList.RemoveAt( 0 );
			pMailList->DeleteFromServer( MessageNo);
		}
	}
	else
	{
		// Get Mail List
		CMailList *MailList;
		if( TreePane->SelectionFolder == INBOX )
			MailList = pInBox;
		else if( TreePane->SelectionFolder == OUTBOX )
			MailList = pOutBox;
		else if( TreePane->SelectionFolder == SENTTO )
			MailList = pSentTo;	
		else
			return;
		int nItem = -1;
		for (int i=0; i < Count; i++)
		{
			nItem = MailListCtrl.GetNextItem(nItem, LVNI_SELECTED);
			if( nItem == -1 )
				break;
			WORD MessageNo = (WORD) MailListCtrl.GetItemData( nItem );
			MailList->DeleteMail( MessageNo );
		}
		TreePane->UpdateList( MailList );
	}
}

void CMainFrame::OnUpdateDelete(CCmdUI* pCmdUI) 
{
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	POSITION pos = MailListCtrl.GetFirstSelectedItemPosition( ) ;
	if(pos == NULL)
	{
		//No Selection !!!
		pCmdUI->Enable( FALSE );
		return;
	}
	
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		if(	!pMailList || !pMailList->pPOPSocket || 
			!pMailList->pPOPSocket->IsConnected() || 
			pMailList->pPOPSocket->State != IDLE )
		{
			pCmdUI->Enable( FALSE );
		}
		else
		{
			pCmdUI->Enable( TRUE );
		}
	}
	else
	{
		pCmdUI->Enable( TRUE );
	}
}

void CMainFrame::OnUpdateDisconnect(CCmdUI* pCmdUI) 
{
	if(	!pMailList || !pMailList->pPOPSocket || !pMailList->pPOPSocket->IsConnected() )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}

void CMainFrame::OnUpdateReceive(CCmdUI* pCmdUI) 
{
	if(	(!pMailList || !pMailList->pPOPSocket || !pMailList->pPOPSocket->IsConnected() ) &&
		(!pOutBox || !pOutBox->pPOPSocket || !pOutBox->pPOPSocket->IsConnected() )  )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );	
}

BOOL CMainFrame::ReadMailStore( CString &MailStore ,CMailList * MailList)
{
	CFileFind Finder;
	CFileFind FinderNext;
	if( MailStore [ MailStore.GetLength() - 1 ] != '\\' )
		MailStore += '\\';
	CString SearchString = MailStore + "*.*";
	BOOL bWorking = Finder.FindFile( SearchString );
	CString FileName, FileNameNext, Folder;
	while (bWorking)
	{
		bWorking = Finder.FindNextFile();
		FileName = Finder.GetFileName();
		if( Finder.IsDirectory() )
		{
			
			if( FileName.CompareNoCase(".") && FileName.CompareNoCase("..") )
			{
				Folder = MailStore + FileName + "\\*.*";
				BOOL bNext = FinderNext.FindFile(Folder);
				while (bNext)
				{
					bNext = FinderNext.FindNextFile();
					FileNameNext = FinderNext.GetFileName();
					if(  FinderNext.IsDirectory() && FileNameNext.CompareNoCase(".") && FileNameNext.CompareNoCase("..") )
						CMixFile::ReadMIX(MailStore + FileName + "\\" + FileNameNext, MailList);

				}
			}
		}
		else if( FileName.Compare( "Mail Index.mix" ) == 0 )
		{
			CMixFile::ReadMIX( MailStore, MailList );
		}
	}
	return TRUE;
}

void CMainFrame::OnNewMail() 
{
	CMailDoc *pDoc = (CMailDoc *) ComposeMail( NULL );	
	pDoc->Compose = TRUE;
}

void CMainFrame::OnSend() 
{
	if( pOutBox )
	{
		if( Authentication )
		{
			if( !pMailList || !pMailList->pPOPSocket || !pMailList->pPOPSocket->IsConnected() ) //Not POPing
			{
				pOutBox->GetAuthentication(SMTPServer, POPServer, Username, Password );
			}
			else
			{
				// POP-ing
				// Will have to check state...
				if( pMailList->pPOPSocket->IsAuthenticated() )
				{
					pMailList->pPOPSocket->DonotQuit();
					pOutBox->SendMail( SMTPServer );										
				}
				else if( pMailList->pPOPSocket->IsQuiting() )
				{
					// Wait till POPserver quits
					pOutBox->WaitingForPOPQuiting = TRUE;
					pOutBox->CreateSendDialogBox();
					pOutBox->SendDlg.SetHeader( "Waiting for POP session to end...");
					// pOutBox->GetAuthentication(SMTPServer, POPServer, Username, Password );
				}
				else
				{
					//Attempting authentication...
					//Wait for Authentication and then send
					pOutBox->WaitingForAuthentication = TRUE;
					pOutBox->CreateSendDialogBox();
					pOutBox->SendDlg.SetHeader( "Waiting for POP authentication...");
				}
			}
		}
		else
			pOutBox->SendMail( SMTPServer );
	}
}

void CMainFrame::OnUpdateSend(CCmdUI* pCmdUI) 
{
	if( pOutBox && pOutBox->GetCount( Address ) )
	{
		if( ! pOutBox->pSMTPSocket || ( pOutBox->pSMTPSocket->State == NOTCONNECTED && !pOutBox->WaitingForAuthentication) )
			pCmdUI->Enable( TRUE );
		else
			pCmdUI->Enable( FALSE );
	}
	else
	{
		pCmdUI->Enable( FALSE );
	}
}

CDocument * CMainFrame::ShowMail(const char *Filename)
{
	/*
	CSingleDocTemplate * pDocTemplateAux;
	pDocTemplateAux = new CSingleDocTemplate(
		IDR_READ,
		RUNTIME_CLASS(CMailDoc),
		RUNTIME_CLASS(CAuxFrame),       // main SDI frame window
		RUNTIME_CLASS(CMailView));
*/
	CFile File;
	if( !File.Open( Filename , CFile::modeRead ) )
	{	
		AfxMessageBox( "Unable to open file.");
		return NULL;
	}
	File.Close();

//	CMailDoc *pDoc = (CMailDoc *) pDocTemplateAux->OpenDocumentFile( Filename );
	CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( Filename );

	CAuxFrame * FrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	FrameWindow->CreateAddressBar( IDD_ADDRESS_RO );
	FrameWindow->SetDlgItem( IDC_FROM_RO, pDoc->From );
	FrameWindow->SetDlgItem( IDC_SUBJECT_RO, pDoc->Subject );
	FrameWindow->SetDlgItem( IDC_TO_RO, pDoc->To );
	FrameWindow->SetDlgItem( IDC_CC_RO, pDoc->CC );
	pDoc->SetViewReadOnly( TRUE );
	pDoc->SetModifiedFlag( FALSE );
	return pDoc;
}

CDocument * CMainFrame::ComposeMail(const char *Filename)
{
	/*
	CSingleDocTemplate * pDocTemplateAux;
	pDocTemplateAux = new CSingleDocTemplate(
		IDR_READ,
		RUNTIME_CLASS(CMailDoc),
		RUNTIME_CLASS(CAuxFrame),       // main SDI frame window
		RUNTIME_CLASS(CMailView));

	CMailDoc *pDoc = (CMailDoc *) pDocTemplateAux->OpenDocumentFile( Filename );
	*/
	CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( Filename );

	if( !pDoc )
	{
		AfxMessageBox( "File not found" );
		return NULL;
	}
	CAuxFrame * FrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	
	FrameWindow->CreateAddressBar( IDD_ADDRESS_RW );
	
	if( Filename == NULL )
		FrameWindow->SetDlgItem( IDC_FROM_RW, Address );
	else
	{
		FrameWindow->SetDlgItem( IDC_FROM_RW, pDoc->From );
		FrameWindow->SetDlgItem( IDC_SUBJECT_RW, pDoc->Subject );
		FrameWindow->SetDlgItem( IDC_TO_RW, pDoc->To );
		FrameWindow->SetDlgItem( IDC_CC_RW, pDoc->CC );
	}

	pDoc->Compose = TRUE;
	pDoc->SetModifiedFlag( FALSE );
	return pDoc;
}

LRESULT CMainFrame::OnAddition(WPARAM wParam, LPARAM lParam)
{
	if( wParam == OUTBOX )
	{
		CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
		
		pOutBox->RemoveAll();
		CString MailStore = CPostmanApp::AppData + "OutBox\\";
		ReadMailStore( MailStore ,pOutBox);
		if( TreePane->SelectionFolder == OUTBOX)
			TreePane->UpdateList( pOutBox );
	}
	return 0;
}

void CMainFrame::OnMailSent(DWORD No, BOOL Success)
{
	CString SentTo= CPostmanApp::AppData + "Sent To\\";
	CPostmanApp::CreateFolder( SentTo );
	if( Success )
	{
		//pOutBox->DeleteMail( No );
		pOutBox->MoveTo( No, SentTo ,pSentTo);
		CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
		if( TreePane->SelectionFolder == OUTBOX )
		{
			TreePane->UpdateList( pOutBox );
		}
		else if( TreePane->SelectionFolder == SENTTO )
		{
			TreePane->UpdateList( pSentTo );
		} 
	}
	else
	{
		CMail *Mail = pOutBox->GetMail( No );
		Mail->Error = TRUE;
	}
}

void CMainFrame::OnDownload() 
{
	CMail *Mail;
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();


	if( !pMailList || !pMailList->pPOPSocket || pMailList->pPOPSocket->State != IDLE )
	{
		MessageBox("Please Wait.\r\nCannot download now");
		return;
	}

	int MessageNo;
	int Count = MailListCtrl.GetSelectedCount( );
	if( Count == 0 )
	{
		//No item selected...
		return;
	}
	int nItem = -1;
	for (int i=0; i < Count; i++)
	{
		nItem = MailListCtrl.GetNextItem(nItem, LVNI_SELECTED);
		if( nItem == -1 )
			break;
		int MessageNo = MailListCtrl.GetItemData( nItem );
		DownloadList.Add( MessageNo );
	}
	while( DownloadList.GetUpperBound( ) != -1 )
	{
		MessageNo = DownloadList.GetAt( 0 );
		Mail = pMailList->GetMail( MessageNo );
		if( Mail )
		{
			FILE*fp;
			if( !Mail->FileName.IsEmpty())
			{
				fp = fopen( (LPCSTR)Mail->FileName, "r");
				if( fp )
				{
					fclose( fp );
					DownloadList.RemoveAt( 0 );
					continue;
				}
			}
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
			DownloadList.RemoveAt( 0 );
			Download(Mail);
			break;
		}
	}
}

void CMainFrame::OnDownloadAll() 
{
	if( !pMailList || !pMailList->pPOPSocket || pMailList->pPOPSocket->State != IDLE )
	{
		MessageBox("Please Wait.\r\nCannot download now");
		return;
	}

	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	int Data = 0;
	int Count = MailListCtrl.GetItemCount( );
	// getting the Numbers to be downloaded...
	for( int i = 0; i < Count; i++ )
	{
		Data = MailListCtrl.GetItemData( i );
		DownloadList.Add( Data );
	}
	while( DownloadList.GetUpperBound( ) != -1 )
	{
		Data = DownloadList.GetAt( 0 );
		CMail * Mail = pMailList->GetMail( Data );
		if( Mail )
		{
			FILE*fp;
			if( !Mail->FileName.IsEmpty() && (fp=fopen( (LPCSTR)Mail->FileName, "r") ) )
			{
				DownloadList.RemoveAt( 0 );
				continue;
			}
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
			DownloadList.RemoveAt( 0 );
			Download(Mail);
			break;
		}
	}
}

void CMainFrame::OnUpdateDownloadAll(CCmdUI* pCmdUI) 
{
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		if( !pMailList || !pMailList->pPOPSocket || pMailList->pPOPSocket->State != IDLE )
			pCmdUI->Enable( FALSE );
		else
			pCmdUI->Enable( TRUE );
	}
	else
		pCmdUI->Enable( FALSE );
}

void CMainFrame::Download(CMail *Mail)
{
	CString Message;
	CPostmanApp::GetTempFileName( Mail->FileName, CPostmanApp::AppData + "Inbox" + "\\" + pMailList->pPOPSocket->m_POPServer + "\\" + pMailList->pPOPSocket->m_UserName );
	Mail->pFilePointer = fopen( (LPCSTR)Mail->FileName, "wb");
	pMailList->pPOPSocket->Mail = Mail;
	pMailList->pPOPSocket->BytesReceived = 0;
	Message.Format("RETR %d\r\n", Mail->No );
	pMailList->pPOPSocket->Send( (LPCSTR) Message, Message.GetLength() );
	pMailList->pPOPSocket->LastCommand = RETR;
	pMailList->pPOPSocket->State=TRANSACTION;
	Message = "C:" + Message;
	pMailList->ReceiveDlg.AddToStatus( Message );
}

void CMainFrame::OnRead() 
{
	CMailList *pML;
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == INBOX )
	{
		pML = pInBox;
	}
	else if( TreePane->SelectionFolder == OUTBOX )
	{
		pML = pOutBox;
	}
	else if( TreePane->SelectionFolder == MAILSERVER )
	{
		pML = pMailList;
	}
	else if( TreePane->SelectionFolder == SENTTO )
	{
		pML = pSentTo;
	}
	else if( TreePane->SelectionFolder == DELETED )
	{
		pML = pDeleted;
	}
	else
	{
		AfxMessageBox("Unable to read");
		return;
	}
	
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	int Count = MailListCtrl.GetSelectedCount( );
	if( Count == 0 )
	{
		//No item selected...
		return;
	}
	int nItem = -1;
	for (int i=0; i < Count; i++)
	{
		nItem = MailListCtrl.GetNextItem(nItem, LVNI_SELECTED);
		if( nItem == -1 )
			break;
		DWORD MessageNo = MailListCtrl.GetItemData( nItem );

		CMail *Mail = pML->GetMail( (WORD) MessageNo );
		CDocument * Doc ;
		if( Mail && !Mail->FileName.IsEmpty() )
		{
			FILE*fp;
			if( fp=fopen( (LPCSTR)Mail->FileName, "r") )
			{
				fclose(fp);
			}
			else
			{
				if( TreePane->SelectionFolder == MAILSERVER )
				{
					AfxMessageBox(" Mail has to be downloaded first!\r\nDownloading mail...");
					DownloadList.Add( Mail->No);
				}
				else
				{
					AfxMessageBox( "File not found" );
				}
				return;
			}
			if( TreePane->SelectionFolder == OUTBOX )
				Doc = ComposeMail( (LPCSTR) Mail->FileName );
			else
				Doc = ShowMail( (LPCSTR) Mail->FileName );
		}
		else
		{
			AfxMessageBox("Unable to read. File name not specified.");
		}
	}
	int Data;
	while( DownloadList.GetUpperBound( ) != -1 )
	{
		Data = DownloadList.GetAt( 0 );
		CMail * Mail = pMailList->GetMail( Data );
		if( Mail )
		{
			FILE*fp;
			if( !Mail->FileName.IsEmpty() && ( fp=fopen( (LPCSTR)Mail->FileName, "r") ) )
			{
				DownloadList.RemoveAt( 0 );
				continue;
			}
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
			DownloadList.RemoveAt( 0 );
			Download(Mail);
			break;
		}
	}
}

BOOL CMainFrame::GetServers()
{
	if( WelcomeDlg.DoModal() != IDOK )
		return FALSE;

	POPServer = WelcomeDlg.POPServer;
	SMTPServer = WelcomeDlg.SMTPServer ;
	Address = WelcomeDlg.Address;
	Username = WelcomeDlg.Username;
	Password = WelcomeDlg.Password;
	Authentication = WelcomeDlg.Authentication;
	return TRUE;
}

void CMainFrame::OnServers() 
{
	GetServers();	
}

void CMainFrame::OnUser() 
{
	UserDlg.m_Username = Username;
	UserDlg.m_Password = Password;
	UserDlg.m_Address = Address;
	if( UserDlg.DoModal() == IDOK )
	{
		Username	= UserDlg.m_Username ;
		Password	= UserDlg.m_Password;
		Address		= UserDlg.m_Address;
	}
	
}

void CMainFrame::OnUpdateUser(CCmdUI* pCmdUI) 
{
}

void CMainFrame::OnUpdateServers(CCmdUI* pCmdUI) 
{
}

void CMainFrame::OnMailDelete(DWORD No, BOOL Success)
{
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == MAILSERVER )
	{
		TreePane->UpdateList( pMailList );
	}
	if ( DeleteList.GetUpperBound( ) != -1 )
	{
		WORD MessageNo = DeleteList.GetAt( 0 );
		DeleteList.RemoveAt( 0 );
		pMailList->DeleteFromServer( MessageNo);
	}
	if( !Success )
		AfxMessageBox("Error deleting mail");
}

void CMainFrame::OnSMTPAuthentication(BOOL Success)
{
	if( pMailList && pMailList->pPOPSocket )
		pMailList->pPOPSocket->CanQuit();
}

void CMainFrame::OnPOPAuthentication(BOOL Success)
{
	if( Success && pOutBox && pOutBox->WaitingForAuthentication )
	{
		pOutBox->WaitingForAuthentication = FALSE;
		pOutBox->SendMail( SMTPServer );
	}
}

void CMainFrame::OnPOPQuit()
{
	if( pOutBox && pOutBox->WaitingForPOPQuiting )
	{
		pOutBox->GetAuthentication(SMTPServer, POPServer, Username, Password );
		pOutBox->WaitingForPOPQuiting = FALSE;
	}
}

void CMainFrame::OnSMTPQuit()
{

}

void CMainFrame::OnClose() 
{
	if( pOutBox && pOutBox->GetCount() )
		AfxMessageBox("There are unsent messages in the outbox");
	CFrameWnd::OnClose();
}

CString CMainFrame::GetFromAddress()
{
	return Address;
}

void CMainFrame::OnViewSenddialogbox() 
{
	if( pOutBox && IsWindow( pOutBox->SendDlg.m_hWnd ) )
	{
		if( pOutBox->SendDlg.IsWindowVisible( ) )
			pOutBox->SendDlg.ShowWindow( SW_HIDE );
		else
			pOutBox->SendDlg.ShowWindow( SW_SHOW );
	}
}

void CMainFrame::OnUpdateViewSenddialogbox(CCmdUI* pCmdUI) 
{
	if( !pOutBox )
		pCmdUI->Enable( FALSE );
	else
	{
		if( !IsWindow( pOutBox->SendDlg.m_hWnd ) )
			pCmdUI->Enable( FALSE );		
		else
		{
			pCmdUI->Enable( TRUE );
			if( pOutBox->SendDlg.IsWindowVisible( ) )	
				pCmdUI->SetCheck( );
			else
				pCmdUI->SetCheck( 0 );
		}
	}
}

void CMainFrame::OnViewReceivedialogbox() 
{
	if( pMailList && IsWindow( pMailList->ReceiveDlg.m_hWnd ) )
	{
		if( pMailList->ReceiveDlg.IsWindowVisible( ) )
			pMailList->ReceiveDlg.ShowWindow( SW_HIDE );
		else
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
	}
}

void CMainFrame::OnUpdateViewReceivedialogbox(CCmdUI* pCmdUI) 
{
	if(!pMailList )
		pCmdUI->Enable( FALSE );
	else
	{
		if( !IsWindow( pMailList->ReceiveDlg.m_hWnd ) )
			pCmdUI->Enable( FALSE );
		else
		{
			pCmdUI->Enable( TRUE );
			if( pMailList->ReceiveDlg.IsWindowVisible( ) )
				pCmdUI->SetCheck( );
			else
				pCmdUI->SetCheck( 0 );
		}
	}
}

BOOL CMainFrame::IsSending()
{
	if( ( !pOutBox || !pOutBox->pSMTPSocket || pOutBox->pSMTPSocket->State == NOTCONNECTED ) && 
		(!pOutBox || !pOutBox->pPOPSocket || !pOutBox->pPOPSocket->IsConnected() ) )
		return FALSE;
	else
		return TRUE;
}

BOOL CMainFrame::IsReceiving()
{
	if(	!pMailList || !pMailList->pPOPSocket || !pMailList->pPOPSocket->IsConnected() )
		return FALSE;
	else
		return TRUE;
}

void CMainFrame::StopSending()
{
	pMailList->ForceStop( FALSE );
}

void CMainFrame::StopReceiveing()
{
	pMailList->ForceStop( TRUE );
}

void CMainFrame::OnReadSpecial() 
{
	CMailList *pML;
	CTreePane *TreePane = ( CTreePane *) m_wndSplitter.GetPane(0,0);
	if( TreePane->SelectionFolder == INBOX )
	{
		pML = pInBox;
	}
	else if( TreePane->SelectionFolder == OUTBOX )
	{
		pML = pOutBox;
	}
	else if( TreePane->SelectionFolder == MAILSERVER )
	{
		pML = pMailList;
	}
	else if( TreePane->SelectionFolder == SENTTO )
	{
		pML = pSentTo;
	}
	else if( TreePane->SelectionFolder == DELETED )
	{
		pML = pDeleted;
	}
	else
	{
		AfxMessageBox("Unable to read");
		return;
	}
	
	CListPane *ListPane = ( CListPane *) m_wndSplitter.GetPane(0,1);
	CListCtrl &MailListCtrl = ListPane->GetListCtrl();
	int Count = MailListCtrl.GetSelectedCount( );
	if( Count == 0 )
	{
		//No item selected...
		return;
	}
	int nItem = -1;
	for (int i=0; i < Count; i++)
	{
		nItem = MailListCtrl.GetNextItem(nItem, LVNI_SELECTED);
		if( nItem == -1 )
			break;
		DWORD MessageNo = MailListCtrl.GetItemData( nItem );

		CMail *Mail = pML->GetMail( (WORD) MessageNo );
		CDocument * Doc ;
		if( Mail && !Mail->FileName.IsEmpty() )
		{
			FILE*fp;
			if( fp=fopen( (LPCSTR)Mail->FileName, "r") )
			{
				fclose(fp);
			}
			else
			{
				if( TreePane->SelectionFolder == MAILSERVER )
				{
					AfxMessageBox(" Mail has to be downloaded first!\r\nDownloading mail...");
					DownloadList.Add( Mail->No);
				}
				else
					AfxMessageBox( "File not found" );
				return;
			}
/*			if( TreePane->SelectionFolder == OUTBOX )
				Doc = ComposeMail( (LPCSTR) Mail->FileName );
			else*/
			Doc = ReadSpecial( (LPCSTR) Mail->FileName );
		}
		else
		{
			AfxMessageBox("Unable to read. File name not specified.");
		}
	}
	int Data;
	while( DownloadList.GetUpperBound( ) != -1 )
	{
		Data = DownloadList.GetAt( 0 );
		CMail * Mail = pMailList->GetMail( Data );
		if( Mail )
		{
			FILE*fp;
			if( !Mail->FileName.IsEmpty() && ( fp=fopen( (LPCSTR)Mail->FileName, "r") ) )
			{
				DownloadList.RemoveAt( 0 );
				continue;
			}
			pMailList->ReceiveDlg.ShowWindow( SW_SHOW );
			DownloadList.RemoveAt( 0 );
			Download(Mail);
			break;
		}
	}
}

CDocument * CMainFrame::ReadSpecial(const char *Filename)
{
	//CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( Filename );
	CSingleDocTemplate * pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_READ,
		RUNTIME_CLASS(CEditorDoc),
		RUNTIME_CLASS(CAuxFrame),       // main SDI frame window
		RUNTIME_CLASS(CEditorView));
	CEditorDoc *pDoc = (CEditorDoc *) pDocTemplate->OpenDocumentFile( Filename );

	if( !pDoc )
	{
		AfxMessageBox( "File not found" );
		return NULL;
	}
	CAuxFrame * FrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	
	FrameWindow->CreateAddressBar( IDD_ADDRESS_RW );
	
	if( Filename == NULL )
		FrameWindow->SetDlgItem( IDC_FROM_RW, Address );
	else
	{
		FrameWindow->SetDlgItem( IDC_FROM_RW, pDoc->From );
		FrameWindow->SetDlgItem( IDC_SUBJECT_RW, pDoc->Subject );
		FrameWindow->SetDlgItem( IDC_TO_RW, pDoc->To );
		FrameWindow->SetDlgItem( IDC_CC_RW, pDoc->CC );
	}
//	pDoc->Compose = FALSE;
	pDoc->SetModifiedFlag( FALSE );
	return pDoc;
}