// Postman.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Postman.h"

#include "MainFrm.h"
#include "PostmanDoc.h"
#include "ListPane.h"
#include "TreePane.h"
#include "AuxFrame.h"
#include "MailView.h"
#include "MailDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPostmanApp

BEGIN_MESSAGE_MAP(CPostmanApp, CWinApp)
	//{{AFX_MSG_MAP(CPostmanApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_MESSAGE( WM_USER+1, OnCloseDocument )
    
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPostmanApp construction

CPostmanApp::CPostmanApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	AppData = "C:\\WINDOWS\\Application Data\\Purayidathil\\Postman\\";
	Start = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPostmanApp object

CString CPostmanApp::AppData;
CPostmanApp theApp;


/////////////////////////////////////////////////////////////////////////////
// CPostmanApp initialization

BOOL CPostmanApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	
	AfxEnableControlContainer();

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Purayidam Software"));
	
	HKEY hKey;
	char str[200];
	unsigned long size = 200;
	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegQueryValueEx(hKey,"AppData",0,NULL,(BYTE *)str,&size);
		RegCloseKey(hKey);	
		AppData = str;
		if( AppData[ AppData.GetLength() - 1 ] != '\\' )
			AppData += '\\';
		AppData += "Purayidathil\\Postman\\";
	}	
	

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CPostmanDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CListPane));

	pDocTemplate->OpenDocumentFile(NULL);

	CMainFrame *FrameWnd = ( CMainFrame * ) m_pMainWnd;

	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	if(! FrameWnd->GetServers() )
		return FALSE;
	return TRUE;	
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_Licensee;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_Licensee = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_LICENSEE, m_Licensee);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CPostmanApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CPostmanApp message handlers


void CPostmanApp::CreateFolder(CString &Folder)
{
	BOOL ret=FALSE;
	int i;
	CString Temp;
	int Length = Folder.GetLength();
	for(i=0;i<Length;i++)
	{
		Temp+=Folder[i];
		if(i>3 && Folder[i]=='\\')
			CreateDirectory(Temp,NULL);
	}
	CreateDirectory(Temp,NULL);
}

void CPostmanApp::GetTempFileName(CString &FullName, CString &Path)
{
	static int i = 0;
	CString Name;
	FILE *fp;
	if( Path.GetLength() && Path[ Path.GetLength()-1 ] != '\\' )
		Path += '\\';
	while(1)
	{
		Name.Format("%0.3d.eml",i);
		FullName = Path + Name ;
		fp = fopen( (LPCSTR) FullName, "r");
		if( !fp )
		{
			fp = fopen( (LPCSTR) FullName, "w");
			if( fp )
			{
				fclose( fp );
				_unlink( FullName );
				return;
			}
			TRACE("Error generating a file name");
		}
		else
			fclose( fp );
		i++;
	}
	
}

void CPostmanApp::GetDateString(CString &Date)
{
	tzset(); 
	long timezone = _timezone/60;
	int tzhour, tzmin, hr, min, sec, day, year;
	char tzsign = '+';
	char month[12][4] = {
						"Jan",
						"Feb",
						"Mar",
						"Apr",
						"May",
						"Jun",
						"Jul",
						"Aug",
						"Sep",
						"Oct",
						"Nov",
						"Dec",
						};
	char dow[7][4] = 
	{
		"Sun",
		"Mon",
		"Tue",
		"Wed",
		"Thu",
		"Fri",
		"Sat",
	};	
	
	if( timezone < 0 )
		timezone = - timezone;
	else
		tzsign = '-';
	tzmin = timezone % 60;
	tzhour = timezone / 60;

	struct tm *newtime;
    time_t long_time;

	time( &long_time );                /* Get time as long integer. */
	newtime = localtime( &long_time ); /* Convert to local time. */
	hr = newtime->tm_hour;
	min = newtime->tm_min;
	sec = newtime->tm_sec;
	day = newtime->tm_mday;
	year = newtime->tm_year +1900;
	
	Date.Format("%s, %d %s %0.4d %0.2d:%0.2d:%0.2d %c%0.2d%0.2d",dow[ newtime->tm_wday], day, month[newtime->tm_mon], year, hr, min, sec, tzsign, tzhour, tzmin);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
		
	HKEY hKey;
	char str[40];
	unsigned long size = 40;
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion",
		0,KEY_SET_VALUE,&hKey)==ERROR_SUCCESS)
	{
		RegQueryValueEx(hKey,"RegisteredOwner",0,NULL,(BYTE *)str,&size);
		RegCloseKey(hKey);	
	}	
	
	m_Licensee = str;
	UpdateData(FALSE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CTime CPostmanApp::ConvertDate(CString Date)
{
	CString FormattedDate = Date;
	
	int mm = 0, dd = 0, yy = 0, hr = 0, min=0, sec = 0, thiszone = 0, zone;
	if( Date.IsEmpty() )
		return CTime(yy, mm, dd, hr, min, sec);	
	tzset(); 
	long timezone = _timezone/60;
	thiszone = ( timezone  / 60 );
	thiszone = -( ( timezone % 60 ) + ( thiszone * 100 ) );
	zone = thiszone;

	char Month[5];
	Date.TrimLeft();
	Date.TrimRight();
	Date.MakeUpper();
	if( Date[0] == 'M' || Date[0] == 'T' || Date[0] == 'W' || Date[0] == 'F' ||Date[0] == 'S' )
	{
		Date = Date.Right( Date.GetLength() - Date.Find(',') - 1);
	}
	Date.TrimLeft();
	sscanf( (LPCSTR) Date, "%d %s %d %d:%d:%d", &dd, Month, &yy, &hr, &min, &sec);
	Date = Date.Right( Date.GetLength() - Date.ReverseFind(':') - 1);
	Date.TrimLeft();
	if( Date.Find(' ') > 0 )
	{
		Date = Date.Right( Date.GetLength() - Date.Find(' ') - 1);
		sscanf( (LPCSTR) Date, "%d", &zone);
	}

	if( Month[0] == 'J')
	{
		if( Month[1] == 'A' )
			mm = 1;
		else if( Month[1] == 'U' && Month[2] == 'N'  )
			mm = 6;
		else
			mm = 7;
	}
	else if( Month[0] == 'F')
		mm = 2;
	else if( Month[0] == 'M' && Month[1] == 'A' )
	{
		if( Month[2] == 'R' )
			mm = 3;
		else
			mm = 5;
	}
	else if( Month[0] == 'A')
	{
		if( Month[1] == 'P' )
			mm = 4;
		else
			mm = 8;
	}
	else if( Month[0] == 'S')
		mm = 9;
	else if( Month[0] == 'O')
		mm = 10;
	else if( Month[0] == 'N')
		mm = 11;
	else if( Month[0] == 'D')
		mm = 12;

	CTimeSpan Span(0, (thiszone - zone ) / 100 , (thiszone - zone ) % 100 , 0 );
	//( int nYear, int nMonth, int nDay, int nHour, int nMin, int nSec, int nDST = -1 );
	CTime Time(yy, mm, dd, hr, min, sec);	
	Time += Span;
		
	return Time;
}

CDocument * CPostmanApp::GetAuxDocument( const char *Filename )
{
	AuxDocuments *New;
	static WORD ID = 1;
	New = new 	AuxDocuments;
	New->pTemplate = new CSingleDocTemplate(
		IDR_READ,
		RUNTIME_CLASS(CMailDoc),
		RUNTIME_CLASS(CAuxFrame),       // main SDI frame window
		RUNTIME_CLASS(CMailView));
	New->ID = ID;
	
	New->Next = Start;
	Start = New;
	CMailDoc *pDoc = (CMailDoc *) New->pTemplate->OpenDocumentFile( Filename );
	New->pDoc = pDoc;
	pDoc->ID = ID;
	ID++;
	return pDoc;
}

LRESULT CPostmanApp::OnCloseDocument(WPARAM ID, LPARAM lParan)
{
	AuxDocuments *Temp, *Prev;
	for( Temp = Start, Prev = Start; Temp != NULL; Prev = Temp, Temp=Temp->Next )
	{
		if( Temp->ID == ID )
		{
			delete Temp->pTemplate;
			if( Temp == Start )
				Start = Temp->Next;
			else
				Prev->Next = Temp->Next;
			delete Temp;
			return 1;
		}
	}
	AfxMessageBox( "Document not found");
	return 0;
}



BOOL CPostmanApp::CanCloseDocuments()
{
	// Checking if currently sending/receiveing mail...
	CMainFrame *FrameWnd = ( CMainFrame * ) m_pMainWnd;	
	if( FrameWnd->IsSending() )
	{
		if( AfxMessageBox( "I am now sending mail. Do you want me to abort", MB_YESNO ) == IDNO)
			return FALSE;
		FrameWnd->StopSending();
	}
	if( FrameWnd->IsSending() )
	{
		if( AfxMessageBox( "I am now receiving mail. Do you want me to abort", MB_YESNO ) == IDNO)
			return FALSE;
		FrameWnd->StopReceiveing();
	}

	AuxDocuments *Temp;
	for( Temp = Start; Temp != NULL; Temp=Temp->Next )
	{
		if( !Temp->pDoc->CanCloseFrame( Temp->pDoc->GetFrame() ) )
			return FALSE;
	}
	
	return TRUE;
}

BOOL CPostmanApp::CompareAddresses(CString &One, CString &Two)
{
	if( One.Compare( Two ) == 0 )
		return TRUE;
	else
		return FALSE;
}
