// ReceiveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "postman.h"
#include "SndRecvDlg.h"
#include "Mail.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSndRecvDlg dialog


CSndRecvDlg::CSndRecvDlg(BOOL bType, CWnd* pParent /*=NULL*/)
	: CDialog( CSndRecvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSndRecvDlg)
	m_Count = _T("");
	m_Header = _T("");
	//}}AFX_DATA_INIT
	pMailList = NULL;
	bReceive = bType;
}


void CSndRecvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSndRecvDlg)
	DDX_Control(pDX, IDC_STOP, m_Stop);
	DDX_Control(pDX, IDC_FORCESTOP, m_ForceStop);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Control(pDX, IDC_ANIMATION, m_Animate);
	DDX_Control(pDX, IDC_STATUS, m_StatusCtrl);
	DDX_Text(pDX, IDC_COUNT, m_Count);
	DDX_Text(pDX, IDC_HEADER, m_Header);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSndRecvDlg, CDialog)
	//{{AFX_MSG_MAP(CSndRecvDlg)
	ON_BN_CLICKED(IDC_HIDE, OnHide)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_FORCESTOP, OnForcestop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSndRecvDlg message handlers

BOOL CSndRecvDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	HICON m_hIcon = AfxGetApp()->LoadIcon( IDI_INBOX );
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_Stop.EnableWindow( TRUE );	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSndRecvDlg::AddToStatus(CString & Addentum)
{
	if( !IsWindow( m_hWnd ) )
		return;
	CString Status;
	m_StatusCtrl.GetWindowText( Status );
	if( Status.GetLength() > 10000 )
		Status.Empty();
	Status += Addentum + "\r\n";
	m_StatusCtrl.SetWindowText( Status );
	m_StatusCtrl.LineScroll(m_StatusCtrl.GetLineCount() );
	UpdateWindow();
}

void CSndRecvDlg::AddToStatus(char *Addentum)
{
	if( !IsWindow( m_hWnd ) )
		return;
	CString Status;
	m_StatusCtrl.GetWindowText( Status );
	if( Status.GetLength() > 10000 )
		Status.Empty();
	Status += Addentum;
	Status += "\r\n";
	m_StatusCtrl.SetWindowText( Status );
	m_StatusCtrl.LineScroll(m_StatusCtrl.GetLineCount() );
	UpdateWindow();
}

void CSndRecvDlg::OnCancel() 
{
	// DestroyWindow();
	// CDialog::OnCancel();
	ShowWindow( SW_HIDE );
} 

void CSndRecvDlg::OnOK() 
{
	// TODO: Add extra validation here
	 DestroyWindow();		
//	CDialog::OnOK();
//	ShowWindow( SW_HIDE );
}

void CSndRecvDlg::SetHeader(CString &Header)
{
	if( !IsWindow( m_hWnd ) )
		return;
	m_Header = Header;
	UpdateData( FALSE );
}

void CSndRecvDlg::SetHeader(char *Header)
{
	if( !IsWindow( m_hWnd ) )
		return;

	m_Header = Header;
	UpdateData( FALSE );
}

void CSndRecvDlg::OnHide() 
{
	ShowWindow( SW_HIDE );	
}

void CSndRecvDlg::OnStop() 
{
	if( pMailList )
	{
		pMailList->Stop(bReceive);
	}		
	m_Stop.EnableWindow( FALSE );
}

void CSndRecvDlg::OnForcestop() 
{
	if( pMailList )
	{
		pMailList->ForceStop(bReceive);
	}
	ShowWindow( SW_HIDE );
}

void CSndRecvDlg::SetMailList(CMailList *MailList)
{
	pMailList = MailList;
}


