// WelcomeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "postman.h"
#include "WelcomeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CPostmanApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CWelcomeDlg dialog


CWelcomeDlg::CWelcomeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWelcomeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWelcomeDlg)
	//}}AFX_DATA_INIT
	POPServer = theApp.GetProfileString( "Configuration", "POP Server","pop.mail.yahoo.com");
	SMTPServer = theApp.GetProfileString( "Configuration", "SMTP Server","smtp.mail.yahoo.com");
	Address = theApp.GetProfileString( "Configuration", "Address","yourself@yahoo.com");
	Username = theApp.GetProfileString( "Configuration", "Username","yourself");
	Selection = theApp.GetProfileInt( "Configuration", "Selection", 0);
	Authentication = theApp.GetProfileInt( "Configuration", "Authentication", 1);

}


void CWelcomeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWelcomeDlg)
	DDX_Control(pDX, IDC_AUTHENTICATION, m_Authentication);
	DDX_Control(pDX, IDC_USERNAME, m_Username);
	DDX_Control(pDX, IDC_SMTP, m_SMTPServer);
	DDX_Control(pDX, IDC_POP, m_POPServer);
	DDX_Control(pDX, IDC_PASSWORD, m_Password);
	DDX_Control(pDX, IDC_ADDRESS, m_Address);
	DDX_Control(pDX, IDC_ACCOUNT, m_Account);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWelcomeDlg, CDialog)
	//{{AFX_MSG_MAP(CWelcomeDlg)
	ON_CBN_SELCHANGE(IDC_ACCOUNT, OnChangeAccount)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWelcomeDlg message handlers

void CWelcomeDlg::OnCancel() 
{
	// TODO: Add extra cleanup here	
	
	CDialog::OnCancel();
}

void CWelcomeDlg::OnOK() 
{
	m_POPServer.GetWindowText(POPServer );
	m_SMTPServer.GetWindowText( SMTPServer );
	m_Address.GetWindowText(Address );
	m_Username.GetWindowText( Username );
	m_Password.GetWindowText( Password );
	if( POPServer.IsEmpty() )
	{
		AfxMessageBox("You have to specify a POP server");
		return;
	}
	if( SMTPServer.IsEmpty() )
	{
		AfxMessageBox("You have to specify a SMTP server");
		return;
	}
	if( Address.IsEmpty() )
	{
		AfxMessageBox("You have to specify an address.\nSomething like 'yourself@yahoo.com' ");
		return;
	}
	if( Username.IsEmpty() )
	{
		AfxMessageBox("You have to specify a Username.\nIf your address is, say, 'yourself@yahoo.com', the username is probably 'yourself'!");
		return;
	}
	Authentication = m_Authentication.GetCheck( );
	Selection = m_Account.GetCurSel();
	theApp.WriteProfileString( "Configuration", "POP Server", POPServer );
	theApp.WriteProfileString( "Configuration", "SMTP Server", SMTPServer );
	theApp.WriteProfileString( "Configuration", "Address", Address);
	theApp.WriteProfileString( "Configuration", "Username", Username);
	theApp.WriteProfileInt( "Configuration", "Selection", Selection );
	theApp.WriteProfileInt( "Configuration", "Authentication", Authentication );
	
	CDialog::OnOK();
}

BOOL CWelcomeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Account.AddString( "Yahoo! Account");
	m_Account.AddString( "Satyam Account");
	m_Account.AddString( "Netkracker Account");
	m_Account.AddString( "VSNL Account");
	m_Account.AddString( "Other Account");

	
	m_POPServer.SetWindowText( POPServer );
	m_SMTPServer.SetWindowText( SMTPServer );
	m_Address.SetWindowText( Address );
	m_Username.SetWindowText( Username );
	m_Password.SetWindowText( Password );
	m_Authentication.SetCheck( Authentication );
	m_Account.SetCurSel( Selection );
	if( Selection == 4 )
	{
		m_POPServer.SetReadOnly(FALSE);
		m_SMTPServer.SetReadOnly(FALSE);
		m_Authentication.EnableWindow( TRUE );
	}
		
	return TRUE;  
}

void CWelcomeDlg::OnChangeAccount() 
{
	int nIndex = m_Account.GetCurSel();
	
	if( nIndex == 0)//Yahoo!
	{
		m_POPServer.SetWindowText( "pop.mail.yahoo.com");
		m_SMTPServer.SetWindowText("smtp.mail.yahoo.com");
		m_Authentication.SetCheck( 1 );
		m_Authentication.EnableWindow( FALSE );
	}
	else if( nIndex == 1) //Satyam
	{
		m_POPServer.SetWindowText( "imap.satyam.net.in");
		m_SMTPServer.SetWindowText("mail.satyam.net.in");
		m_Authentication.SetCheck( 0 );
	}
	else if( nIndex == 2) //Netkracker
	{
		m_POPServer.SetWindowText( "pop.netkracker.com");
		m_SMTPServer.SetWindowText("smtp.netkracker.com");
		m_Authentication.SetCheck( 0 );
	}
	else if( nIndex == 3) //VSNL
	{
		m_POPServer.SetWindowText( "pop.vsnl.com");
		m_SMTPServer.SetWindowText("smtp.vsnl.com");
		m_Authentication.SetCheck( 0 );
	}

	if( nIndex < 4)
	{
		m_Authentication.EnableWindow( FALSE );
		m_POPServer.SetReadOnly();
		m_SMTPServer.SetReadOnly();
	}
	else
	{
		m_Authentication.EnableWindow( TRUE );
		m_POPServer.SetReadOnly(FALSE);
		m_SMTPServer.SetReadOnly(FALSE);
	}
}
